
/**
 * @file   linux/at/at_assert.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the <assert.h> header.

// Do not include this file in private library code.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
#include <linux/printk.h>

// Macro
/////////////////////////////////////////////////////////////////////////////

#define at_assert(C)                                                                               \
    if (!(C)) { printk(KERN_ERR "at_assert failed at line %d of %s\n", __LINE__, __FILE__); }
