
/**
 * @file   linux/at/at_gate.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

#pragma once

// Data types
/////////////////////////////////////////////////////////////////////////////

struct at_gate
{
    union {
#ifdef MODULE
#ifdef CONFIG_PREEMPT_RT
        struct semaphore mSemaphore;
#else
        spinlock_t mSpinlock;
#endif
#endif
        // Must be aligned to 64 bits
        uint64_t mReserved0[32];
    };
};

struct at_gate_rt
{
    union {
#ifdef MODULE
#ifdef CONFIG_PREEMPT_RT
        struct semaphore mSemaphore;
#endif
#endif
        // Must be aligned to 64 bits
        uint64_t mReserved0[32];
    };
};

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The at public code defines =========================================

extern void at_gate_init(struct at_gate *aThis);
extern void at_gate_lock(struct at_gate *aThis, unsigned long *aLevel);
extern void at_gate_unlock(struct at_gate *aThis, unsigned long *aLevel);

extern void at_gate_rt_init(struct at_gate_rt *aThis);
extern void at_gate_rt_down(struct at_gate_rt *aThis);
extern int at_gate_rt_down_trylock(struct at_gate_rt *aThis);
extern void at_gate_rt_up(struct at_gate_rt *aThis);
