
/**
 * @file   linux/at/at_linux_firmware.c
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
#include <linux/firmware.h>

// ===== linux/at ===========================================================
#include <at_assert.h>
#include <at_linux_firmware.h>

// Functions
/////////////////////////////////////////////////////////////////////////////

// aFirmware [---;R--]
const uint8_t *at_firmware_get_data(const struct firmware *aFirmware)
{
    at_assert(NULL != aFirmware);

    return aFirmware->data;
}

// aFirmware [---;R--]
unsigned int at_firmware_get_size(const struct firmware *aFirmware)
{
    at_assert(NULL != aFirmware);

    return aFirmware->size;
}

// aFirmware [D--;RW-]
void at_firmware_release(const struct firmware *aFirmware)
{
    at_assert(NULL != aFirmware);

    release_firmware(aFirmware);
}

// aFirmware [---;-W-]
int at_firmware_request(const struct firmware **aFirmware,
                        const char *aName,
                        struct device *aDevice)
{
    at_assert(NULL != aFirmware);
    at_assert(NULL != aName);
    at_assert(NULL != aDevice);

    return request_firmware(aFirmware, aName, aDevice);
}
