
/**
 * @file   linux/at/at_linux_firmware.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/firmware.h> header.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
struct firmware;

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The at public code defines =========================================
extern const uint8_t *at_firmware_get_data(const struct firmware *aFirmware);
extern unsigned int at_firmware_get_size(const struct firmware *aFirmware);
extern void at_firmware_release(const struct firmware *aFirmware);
extern int
at_firmware_request(const struct firmware **aFirmware, const char *aName, struct device *aDevice);
