
/**
 * @file   linux/at/at_linux_fs.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/fs.h> header.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
struct file;
struct inode;

// Constants
/////////////////////////////////////////////////////////////////////////////

#ifndef MODULE

#define S_IFREG 0100000
#define S_IRGRP 00040
#define S_IROTH 00004
#define S_IRUSR 00400
#define S_IWGRP 00020
#define S_IWOTH 00002
#define S_IWUSR 00200

#define S_IRUGO (S_IRUSR | S_IRGRP | S_IROTH)
#define S_IWUGO (S_IWUSR | S_IWGRP | S_IWOTH)

#endif

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The at public code defines =========================================
extern void at_file_clear_private_data(struct file *aThis);
extern struct inode *at_file_get_inode(struct file *aThis);
extern void *at_file_get_private_data(struct file *aThis);
extern void at_file_set_private_data(struct file *aThis, void *aData);
