
/**
 * @file   linux/at/at_ioport.c
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
#include <linux/ioport.h>

// ===== linux/at ===========================================================
#include <at_assert.h>

// Functions
/////////////////////////////////////////////////////////////////////////////

void at_release_mem_region(uint64_t aPA, uint32_t aSize_byte)
{
    release_mem_region(aPA, aSize_byte);
}
void at_release_region(uint64_t aPA, uint32_t aSize_byte) { release_region(aPA, aSize_byte); }

// aName [-K-;R--]
void *at_request_mem_region(uint64_t aPA, uint32_t aSize_byte, const char *aName)
{
    at_assert(0 < aSize_byte);
    at_assert(NULL != aName);

    return request_mem_region(aPA, aSize_byte, aName);
}

// aName [-K-;R--]
void *at_request_region(uint64_t aPA, uint32_t aSize_byte, const char *aName)
{
    at_assert(0 < aSize_byte);
    at_assert(NULL != aName);

    return request_region(aPA, aSize_byte, aName);
}
