
/**
 * @file   linux/at/at_linux_kallsyms.c
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/kallsyms.h> header.

// ===== Linux Kernel =======================================================
#include <linux/kallsyms.h>
#include <linux/version.h>

// ===== linux/at ===========================================================
#include <at_assert.h>

#include <at_linux_kallsyms.h>

// Functions
/////////////////////////////////////////////////////////////////////////////

void *at_kallsyms_lookup_name(const char *a_name)
{
    void *l_result = NULL;

    // printk(KERN_DEBUG "%s( \"%s\" )\n", __FUNCTION__, a_name);

    at_assert(NULL != a_name);

#if LINUX_VERSION_CODE < KERNEL_VERSION(5, 7, 0)

    l_result = (void *)kallsyms_lookup_name(a_name);

#endif

    // printk(KERN_NOTICE "INFO in %s - Returns %s\n", __FUNCTION__,
    //        NULL == l_result ? "NULL" : "an address");

    return l_result;
}
