
/**
 * @file   linux/at/at_linux_mempool.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/mempool.h> header.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
struct kmem_cache;
struct mempool_s;

// Data type
/////////////////////////////////////////////////////////////////////////////

#ifndef MODULE

typedef struct mempool_s mempool_t;

#endif

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The public code defines ============================================

extern struct kmem_cache *at_kmem_cache_create(const char *aName, unsigned int aSize);

extern void at_kmem_cache_destroy(struct kmem_cache *aThis);

extern mempool_t *at_mem_pool_create_slab(int aMin, struct kmem_cache *aCache);

extern void *at_mem_pool_alloc(mempool_t *aThis);
extern void at_mem_pool_destroy(mempool_t *aThis);

extern void at_mem_pool_free(void *aElement, mempool_t *aThis);
