
/**
 * @file   linux/at/at_linux_mm.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/mm.h> header.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
struct page;

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The public code defines ============================================

extern uint32_t at_page_align(uint32_t aSize_byte);
extern uint64_t at_page_get_first(void *aAddress);
extern uint64_t at_page_get_last(void *aAddress, size_t aSize_byte);
extern uint64_t at_page_get_mask(void);
extern uint32_t at_page_get_offset(void *aAddress);
extern uint64_t at_page_get_shift(void);
extern uint32_t at_page_get_size(void);
extern int at_page_get_user_pages_fast(void *aAddress,
                                       uint32_t aPageCount,
                                       bool aReadFromCard,
                                       struct page **aPages);

extern void at_page_clear_reserved(struct page *aThis);
extern int at_page_is_reserved(struct page *aThis);
extern void at_page_put(struct page *aThis);
extern void at_page_set_dirty(struct page *aThis);
extern void at_page_set_reserved(struct page *aThis);

extern void at_page_list_put(struct page **aList, unsigned int aCount);
extern void at_page_list_set_dirty(struct page **aList, unsigned int aCount);
