
/**
 * @file   linux/at/at_linux_proc_fs.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/proc_fs.h> header.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kenel ========================================================
struct inode;
struct proc_dir_entry;

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The at public code defines =========================================

extern void *at_inode_get_data(struct inode *aThis);
extern uint32_t at_inode_get_minor(struct inode *aThis);

extern struct proc_dir_entry *at_proc_mkdir(const char *aName, struct proc_dir_entry *aParent);
extern void at_proc_remove(struct proc_dir_entry *aThis);
