
/**
 * @file   linux/at/at_linux_scatterlist.c
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/scatterlist.h> header.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
struct page;
struct scatterlist;

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The at public code defines =========================================
extern void at_scatter_list_assign_page(struct scatterlist *aThis, struct page *aPage);
extern uint64_t at_scatter_list_get_dma_address(struct scatterlist *aThis);
extern uint32_t at_scatter_list_get_dma_len(struct scatterlist *aThis);
extern void *at_scatter_list_get_element(struct scatterlist *aList, uint32_t aIndex);
extern uint32_t at_scatter_list_get_element_size(void);
extern uint32_t at_scatter_list_get_length(struct scatterlist *aThis);
extern uint32_t at_scatter_list_get_offset(struct scatterlist *aThis);
extern void at_scatter_list_init(struct scatterlist *aList, uint32_t aCount);
extern void at_scatter_list_set_length(struct scatterlist *aThis, uint32_t aLength);
extern void at_scatter_list_set_offset(struct scatterlist *aThis, uint32_t aOffset);
extern void at_scatter_list_set_page(struct scatterlist *aThis,
                                     struct page *aPage,
                                     unsigned int aLength,
                                     unsigned int aOffset);
