
/**
 * @file   linux/at/at_linux_seq_file.c
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
#include <linux/seq_file.h>

// ===== linux/at ===========================================================
#include <at_assert.h>

#include <at_linux_seq_file.h>

// Functions
/////////////////////////////////////////////////////////////////////////////

// aThis   [---;R--]
void *at_seq_get_private(struct seq_file *aThis)
{
    at_assert(NULL != aThis);

    return aThis->private;
}

// aThis   [---;RW-]
// aFormat [---;R--]
void at_seq_printf(struct seq_file *aThis, const char *aFormat, ...)
{
    va_list lArgs;

    at_assert(NULL != aThis);
    at_assert(NULL != aFormat);

    va_start(lArgs, aFormat);

    seq_vprintf(aThis, aFormat, lArgs);

    va_end(lArgs);
}
