
/**
 * @file   linux/at/at_linux_vmalloc.c
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
#include <linux/vmalloc.h>

// ===== linux/at ===========================================================
#include <at_assert.h>

#include <at_linux_vmalloc.h>

// Functions
/////////////////////////////////////////////////////////////////////////////

// at_vm_alloc --> at_vm_free
void *at_vm_alloc(size_t aSize_byte)
{
    at_assert(0 < aSize_byte);

    return vmalloc(aSize_byte);
}

// aAddress [D--;---]
//
// at_vm_alloc --> at_vm_free
void at_vm_free(void *aAddress)
{
    at_assert(NULL != aAddress);

    return vfree(aAddress);
}
