
/**
 * @file   linux/at/at_linux_wait.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/wait.h> header.

#pragma once

// Data types
/////////////////////////////////////////////////////////////////////////////

#ifndef MODULE
typedef struct wait_queue_head
{
    // Must be aligned to 64 bits
    uint64_t mReserved0[32];
} wait_queue_head_t;
#else
#include <linux/wait.h>
#endif

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The at public code defines =========================================
extern void at_wait_queue_init(wait_queue_head_t *aThis);
extern int at_wait_queue_wait_event_interruptible(wait_queue_head_t *aThis, uint16_t *aFlag);
extern int at_wait_queue_wait_event_interruptible_timeout(wait_queue_head_t *aThis,
                                                          uint16_t *aFlag,
                                                          int64_t aTimeout);
extern int at_wait_queue_wait_event_interruptible_timeout_eq(wait_queue_head_t *aThis,
                                                             int *aFlag,
                                                             int aValue,
                                                             int64_t aTimeout);
extern void at_wait_queue_wake_up(wait_queue_head_t *aThis);
extern void at_wait_queue_wake_up_interruptible(wait_queue_head_t *aThis);
