
/**
 * @file   linux/at/at_linux_workqueue.c
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
#include <linux/workqueue.h>

// ===== linux/at ===========================================================
#include <at_assert.h>

#include <at_linux_workqueue.h>

// Functions
/////////////////////////////////////////////////////////////////////////////

// aThis     [---;-W-]
// aFunction [-K-;--X]
void at_work_queue_init(struct work_struct *aThis, work_func_t aFunction)
{
    at_assert(NULL != aThis);
    at_assert(NULL != aFunction);

    INIT_WORK(aThis, aFunction);
}

// aThis     [---;RW-]
bool at_work_queue_schedule(struct work_struct *aThis)
{
    at_assert(NULL != aThis);

    return schedule_work(aThis);
}
