
/**
 * @file   linux/at/at_linux_workqueue.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

// This file replace the kernel <linux/workqueue.h> header.

#pragma once

// Data types
/////////////////////////////////////////////////////////////////////////////

#ifndef MODULE

struct work_struct
{
    // Must be aligned to 64 bits
    uint64_t mReserved0[16];
};

typedef void (*work_func_t)(struct work_struct *);

#endif

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The at public code defines =========================================
extern void at_work_queue_init(struct work_struct *aThis, work_func_t aFunction);
extern bool at_work_queue_schedule(struct work_struct *aThis);
