
/**
 * @file   linux/at/at_main.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

#pragma once

// Includes
/////////////////////////////////////////////////////////////////////////////

// ===== Linux kernel =======================================================
struct file;
struct inode;
struct proc_dir_entry;
struct seq_file;

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The private library defines ========================================

extern long at_dispatch_compat_ioctl(struct file *aFile, unsigned int aCmd, unsigned long aArgs);
extern long at_dispatch_ioctl(struct file *aFile, unsigned int aCmd, unsigned long aArgs);
extern int at_dispatch_open(struct inode *aINode, struct file *aFile);
extern int at_dispatch_release(struct inode *aINode, struct file *aFile);

extern int at_procfs_show(struct seq_file *aSeq, void *aOffset);
extern ssize_t
at_procfs_write(struct file *aFile, const char *aBuffer, size_t aSize_byte, loff_t *aOffset);

// ===== The public code defines ============================================

extern void *at_compat_ptr(uint32_t aPtr);

extern void at_procfs_config(struct proc_dir_entry *aThis, void *aContext);
extern struct proc_dir_entry *at_procfs_create_data(const char *aName,
                                                    umode_t aMode,
                                                    struct proc_dir_entry *aParent,
                                                    void *aContext);

extern void at_sprintf(char *aOut, const char *aFormat, ...);
