
/**
 * @file   linux/at/at_params.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2020 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

#pragma once

// Data type
/////////////////////////////////////////////////////////////////////////////

enum at_param_id
{
    AT_PARAM_DMA_DESC_PER_ENGINE,
    AT_PARAM_FIRMWARE_FILE,
    AT_PARAM_LOG_MASK,
    AT_PARAM_MIN_BUFFER_POOL_ITEMS,
    AT_PARAM_USE_INT_CTRL,
    AT_PARAM_USE_MSI,
    AT_PARAM_USE_MSI_MULTI,
    AT_PARAM_USE_MSIX,

    AT_PARAM_QTY
};

// Functions
/////////////////////////////////////////////////////////////////////////////

// ===== The public code defines ============================================
extern int at_param_get(enum at_param_id aId);
extern const char *at_param_get_string(enum at_param_id aId);
extern void at_param_set(enum at_param_id aId, int aValue);