
/**
 * @file   src/ats_types.h
 *
 * @author Alazar Technologies Inc
 *
 * @copyright Copyright (c) 2018 Alazar Technologies Inc. All Rights
 * Reserved.  Unpublished - rights reserved under the Copyright laws
 * of the United States And Canada.
 * This product contains confidential information and trade secrets
 * of Alazar Technologies Inc. Use, disclosure, or reproduction is
 * prohibited without the prior express written permission of Alazar
 * Technologies Inc
 */

// This file is included into the dkms package.

#ifndef ATS_TYPES_H
#define ATS_TYPES_H

#ifdef _WIN32

#include <wchar.h>

#ifndef __cplusplus
#define bool _Bool
#define false 0
#define true 1
#endif // __cplusplus

typedef signed char int8_t;
typedef short int16_t;
typedef int int32_t;
typedef long long int64_t;
typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef unsigned int uint32_t;
typedef unsigned long long uint64_t;
typedef wchar_t ats_char_t;

#define ATTR_PACKED

#else

#ifdef _DRIVER_
#ifdef BLOB
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
typedef void *virt_addr_t;
#else
typedef void *virt_addr_t;
#include <linux/types.h>
#endif
#else
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#endif

typedef uint32_t ULONG32;
typedef uint64_t ULONG64;
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
typedef unsigned char boolean_t;
typedef char ats_char_t;

#define ATTR_PACKED __attribute__((packed))

#endif

typedef size_t index_t;

#endif // ATS_TYPES_H
